
 /*************************************************************************/
 /*************************************************************************

 A C++ Program to implement Add and Subtract function on Big Number Class.

  *************************************************************************/
 /*************************************************************************/

 /*************************************************************************

	  By :
		Muhammad Tahir Shahzad  [ MTS ]
		B.C.S Honours  [ 2000-04 ]
		Government College University Lahore
		Pakistan

      E-mail :  mtshome@wol.net.pk

    Web-Site :  www.mts-home.cjb.net  [ www.wol.net.pk/mtshome ]
		www.mtshome.cjb.net   [ www.geocities.com/mtahirshahzad ]

  *************************************************************************/

 /**************************************************************************/
 //-----------------------------  Header Files  ---------------------------//
 /**************************************************************************/

 # include <iostream.h>
 # include <string.h>
 # include <stdlib.h>
 # include <conio.h>

 /**************************************************************************/
 //--------------------------  Class Definition  --------------------------//
 /**************************************************************************/

  //---------------------------------  List  ------------------------------//

 class List
 {
    public:
       int totalSize;
       int currSize;
       int* array;

    public:
       List( );
       List(int totalSize);
       ~List( );

       void Insert(int value);
       void InsertInSortedOrder(int value);
       int Search(int value);
       void Delete(int index);
       void Print( );
       void PrintInReverseOrder( );
       int Length( );
       void SortAscending( );
       void ReplaceAnElement(int index, int value);
 };

 /**************************************************************************/
 //-------------------------  Function Definitions  -----------------------//
 /**************************************************************************/

 //--------------------------------  List( )  -----------------------------//

 List::List( )
 {
    this->totalSize = 0;
    this->currSize = 0;
    this->array = NULL;
 }

 //--------------------------------  List( )  -----------------------------//

 List::List(int totalSize)
 {
    this->totalSize = totalSize;
    this->currSize = 0;
    this->array = new int[totalSize];

    if (!this->array)
    {
	cout<<"Unable to allocate Memory to the Array.";
	exit(1);
    }
 }

 //-------------------------------  ~List( )  -----------------------------//

 List::~List( )
 {
    delete[] this->array;
 }

 //------------------------------  Insert( )  -----------------------------//

 void List::Insert(int value)
 {
    if (this->currSize < this->totalSize)
    {
       this->array[currSize] = value;

       this->currSize ++;
    }

    else
       cout<<"\nError: Cannot Insert ... Size exceeds"<<endl;
 }

 //----------------------  InsertInSortedOrder( )  -----------------------//

 void List::InsertInSortedOrder(int value)
 {
    if (this->currSize < this->totalSize)
    {
       for (int i = 0; i < this->currSize; i ++)
       {
	   if (this->array[i] > value)
	       break;
       }

       for (int j = this->currSize; j > i; j --)
	   this->array[j] = this->array[j-1];

       this->array[i] = value;
       this->currSize ++;
    }

    else
       cout<<"\nError: Cannot Insert ... Size exceeds"<<endl;
 }

 //------------------------------  Search( )  -----------------------------//

 int List::Search(int value)
 {
    if (this->currSize == 0)
       return -1;

    else
    {
       for (int i = 0; i < this->currSize; i ++)
       {
	   if (this->array[i] == value)
		return i;
       }

       return -1;
    }
 }

 //------------------------------  Delete( )  -----------------------------//

 void List::Delete(int value)
 {
    if (this->currSize == 0)
       cout <<"\nError: Cannot Delete. Array is Empty"<<endl;

    else
    {
       int index = this->Search(value);

       if (index != -1)
       {
	   for (int i = index; i < this->currSize; i ++)
	      this->array[i] = this->array[i+1];

	   this->array[i] = NULL;

	   this->currSize --;
       }
    }
 }

 //-------------------------------  Print( )  -----------------------------//

 void List::Print( )
 {
    if (this->currSize == 0)
       cout<<"\n:: Array is Empty."<<endl;

    else
    {
       cout << "Array = ";

       for (int i = 0; i < this->currSize; i ++)
	   cout << this->array[i] << " ";

       cout<<endl;
    }
 }

 //--------------------------  PrintInReverseOrder( )  --------------------//

 void List::PrintInReverseOrder( )
 {
    if (this->currSize == 0)
       cout<<"\n:: Array is Empty."<<endl;

    else
    {
       cout << "Array = ";

       for (int i = (this->currSize - 1); i >= 0 ; i --)
	   cout << this->array[i] << " ";

       cout<<endl;
    }
 }

 //------------------------------  Length( )  -----------------------------//

 int List::Length( )
 {
    return this->currSize;
 }

 //--------------------------  ReplaceAnElement( )  ----------------------//

 void List::ReplaceAnElement(int index, int value)
 {
    if (index < this->currSize)
       this->array[index] = value;

    else
       cout<<"\nError: Invalid Element Index"<<endl;
 }


 //--------------------------  SortAscending( )  -------------------------//

 void List::SortAscending( )
 {
    if (this->currSize <= 1)
       return;

    else
    {
       for (int i = 0; i < this->currSize; i ++)
       {
	   for (int j = 0; j < (this->currSize - 1); j ++)
	   {
	       if (this->array[j] > this->array[j+1])
	       {
		  int temp = this->array[j];

		  this->array[j] = this->array[j+1];
		  this->array[j+1] = temp;
	       }
	   }
       }
    }
 }


 /**************************************************************************/
 //--------------------------------  main( )  -----------------------------//
 /**************************************************************************/

 int main( )
 {
    clrscr( );

    List Obj(10);

    cout<<"Insert( ) Demonstration"<<endl;
    cout<<"***********************"<<endl;

    cout<<"Insert(5)"<<endl;
    cout<<"Insert(3)"<<endl;
    cout<<"Insert(9)"<<endl;
    cout<<"Insert(12)"<<endl;
    cout<<"Insert(1)"<<endl;
    cout<<"Insert(7)"<<endl;

    Obj.Insert(5);
    Obj.Insert(3);
    Obj.Insert(9);
    Obj.Insert(12);
    Obj.Insert(1);
    Obj.Insert(7);


    cout<<"\n\nPrint( ) Demonstration"<<endl;
    cout<<"**********************"<<endl;

    Obj.Print( );


    cout<<"\n\nPrintInReverseOrder( ) Demonstration"<<endl;
    cout<<"************************************"<<endl;

    Obj.PrintInReverseOrder( );


    cout<<"\n\nLength( ) Demonstration"<<endl;
    cout<<"***********************"<<endl;

    cout<<"Array Length = " << Obj.Length( )<<endl;


    cout<<"\n\nReplaceAnElement( ) Demonstration"<<endl;
    cout<<"*********************************"<<endl;

    cout<<"ReplaceAnElement(0,6)"<<endl;
    cout<<"ReplaceAnElement(2,8)"<<endl<<endl;

    Obj.ReplaceAnElement(0,6);
    Obj.ReplaceAnElement(2,8);

    Obj.Print( );


    cout<<"\n\nSortAscending( ) Demonstration"<<endl;
    cout<<"******************************"<<endl;

    Obj.SortAscending( );
    Obj.Print( );


    cout<<"\n\nInsertInSortedOrder( ) Demonstration"<<endl;
    cout<<"************************************"<<endl;

    cout<<"InsertInSortedOrder(5)"<<endl;
    cout<<"InsertInSortedOrder(0)"<<endl<<endl;

    Obj.InsertInSortedOrder(5);
    Obj.InsertInSortedOrder(0);

    Obj.Print( );

    getch( );

    cout<<"\n\nSearch( ) Demonstration"<<endl;
    cout<<"***********************"<<endl;

    cout << "Search(8)"<<endl;
    int index = Obj.Search(8);

    if (index == -1)
       cout<<"Search Result = Element Not Found"<<endl;

    else
       cout<<"Search Result = Element Found At Arra["<<index<<"]"<<endl;


    cout <<"\nSearch(5)"<<endl;

    index = Obj.Search(5);

    if (index == -1)
       cout<<"Search Result = Element Not Found"<<endl;

    else
       cout<<"Search Result = Element Found At Arra["<<index<<"]"<<endl;


    cout<<"\n\nDelete( ) Demonstration"<<endl;
    cout<<"***********************"<<endl;

    cout << "Delete(8)"<<endl;
    Obj.Delete(8);

    cout << "Delete(5)"<<endl<<endl;
    Obj.Delete(5);

    Obj.Print( );

    getch( );
    return 0;
 }

 /**************************************************************************/
 //--------------------------------  THE END  -----------------------------//
  /**************************************************************************/